﻿Public Class Form1
  Dim WithEvents serialPort As New IO.Ports.SerialPort
  Dim header As String
  Dim mfrID, model, unit As Integer
  Dim Version As String = "1.0.0"
 
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer

        Me.Text = Me.Text & " ver. " & Version

    mfrID = &H7F : model = 4 : unit = 0  ' model 4 is for tonal noise synth
    ''''''''''''''''''''''''''''''''''''''
    header = Chr(&HF0) + Chr(mfrID) + Chr(model) + Chr(unit)   ' sysexe header

    For i = 0 To My.Computer.Ports.SerialPortNames.Count - 1   ' enumerate ports discovered, stuff combo box
      cbCOMPorts.Items.Add(My.Computer.Ports.SerialPortNames(i))
    Next
    cbCOMPorts.SelectedIndex = 0

    lblLev0.Text = 0

    For i = 0 To 16383 Step 100
      cbNCFadsrA0.Items.Add(i)
      cbNCFadsrD0.Items.Add(i)
      cbNCFadsrS0.Items.Add(i)
      cbNCFadsrR0.Items.Add(i)

      cbNCAadsrA0.Items.Add(i)
      cbNCAadsrD0.Items.Add(i)
      cbNCAadsrS0.Items.Add(i)
      cbNCAadsrR0.Items.Add(i)
    Next

    For i = 0 To 67 : cbTRANSPOSE.Items.Add(i) : Next   ' fill the transpose combo box
    cbTRANSPOSE.SelectedIndex = 0

    ' use the control's data.

    ' initialize index ADSR to default values (bell/chime)
    '    cbNCFadsrA0.Text = 16383
    '    cbNCFadsrD0.Text = 16383
    '    cbNCFadsrS0.Text = 16383
    '    cbNCFadsrR0.Text = 30
    '    cbNCFexpoRelease0.Checked = True

    ' initialize amplitude ADSR to default values (bell/chime)
    '    cbNCAadsrA0.Text = 16383
    '    cbNCAadsrD0.Text = 16383
    '    cbNCAadsrS0.Text = 16383
    '    cbNCAadsrR0.Text = 50
    '    cbNCAexpoRelease0.Checked = True

    ' the following code ensures that numerical readouts as labels match the value of the associated control
    Dim ox As System.Object                 ' create a throw away object
    ox = CObj(0)
    tbTuningValue_Scroll(ox, e)
    tbLev0_Scroll(ox, e)
  End Sub
  ' handler for Send button clicks
  Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
    Try
      btnUpdate.BackColor = Color.Red
      btnUpdate.Enabled = False
      btnUpdate.Refresh()
      SendPatch()
      btnUpdate.BackColor = Color.Lime
      btnUpdate.Enabled = True
      btnUpdate.Refresh()
    Catch ex As Exception
      MsgBox("ERROR" & vbCrLf & ex.ToString)
    End Try
  End Sub

  Private Sub Disconnect()
    Try
      serialPort.Close()
    Catch ex As Exception
      MsgBox(ex.ToString)
    End Try
  End Sub

  Private Function Connect()
    Dim success_status As Boolean = True

    Dim baudrate As Integer = 19200

    If (cbCOMPorts.Text <> "COM1") Then baudrate = 115200

    If serialPort.IsOpen Then
      serialPort.Close()
    End If
    Try
      With serialPort
        .PortName = cbCOMPorts.Text
        .BaudRate = baudrate
        .Parity = IO.Ports.Parity.None
        .DataBits = 8
        .StopBits = IO.Ports.StopBits.One
        '            .Encoding = System.Text.Encoding.Unicode
        .Encoding = System.Text.Encoding.Default          ' default is unmodified, 8 bit
      End With
      serialPort.Open()

    Catch ex As Exception
      serialPort.Close()
      success_status = False
      lblStatus.Text = "SEND FAILED"
      lblStatus.Refresh()
      MsgBox("Disconnect the Avnet program from " & cbCOMPorts.Text & ": and try again.")
    End Try

    Return success_status

  End Function

  Private Sub tbLev0_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbNZlev.Scroll
    lblLev0.Text = tbNZlev.Value.ToString()
  End Sub



  Private Sub pnlAMPadsr0_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlAMPadsr0.Paint
    Dim h As Integer = pnlAMPadsr0.Height
    Dim w As Integer = pnlAMPadsr0.Width
    Dim g As Graphics = e.Graphics
    Dim p As Pen = New Pen(Color.Blue, 3)
    Dim v As Integer
    Dim c As Char

    With cbNCAadsrA0
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbNCAadsrD0
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbNCAadsrS0
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbNCAadsrR0
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    Dim P0 As Point = New Point(0, h)
    Dim P1 As Point = New Point(w * 0.3 * ((16383 - Val(cbNCAadsrA0.Text)) / 16383), 0)
    Dim P2 As Point = New Point(P1.X + w * 0.3 * ((16383 - Val(cbNCAadsrD0.Text)) / 16383), ((16383 - Val(cbNCAadsrS0.Text)) / 16383) * h)
    Dim P3 As Point = New Point(P2.X + w * 0.1, ((16383 - Val(cbNCAadsrS0.Text)) / 16383) * h)
    Dim P4 As Point = New Point(P3.X + w * 0.3 * ((16383 - Val(cbNCAadsrR0.Text)) / 16383), h)

    p.Color = Color.ForestGreen
    g.DrawLine(p, P0, P1)

    p.Color = Color.Red
    g.DrawLine(p, P1, P2)

    p.Color = Color.Blue
    g.DrawLine(p, P2, P3)

    p.Color = Color.Black
    g.DrawLine(p, P3, P4)
  End Sub



  '############ AMP ADSR HANDLERS
  Private Sub cbbAMPadsrA0_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbNCAadsrA0.TextChanged
    pnlAMPadsr0.Refresh()
  End Sub
  Private Sub cbbAMPadsrD0_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbNCAadsrD0.TextChanged
    pnlAMPadsr0.Refresh()
  End Sub
  Private Sub cbbAMPadsrS0_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbNCAadsrS0.TextChanged
    pnlAMPadsr0.Refresh()
  End Sub
  Private Sub cbbAMPadsrR0_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbNCAadsrR0.TextChanged
    pnlAMPadsr0.Refresh()
  End Sub
  Private Sub cbbAMPadsrA0_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNCAadsrA0.Validating
    pnlAMPadsr0.Refresh()
  End Sub
  Private Sub cbbAMPadsrD0_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNCAadsrD0.Validating
    pnlAMPadsr0.Refresh()
  End Sub
  Private Sub cbbAMPadsrS0_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNCAadsrS0.Validating
    pnlAMPadsr0.Refresh()
  End Sub
  Private Sub cbbAMPadsrR0_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNCAadsrR0.Validating
    pnlAMPadsr0.Refresh()
  End Sub

  '-------------------------------------------------------------------------------------------------------------

  Private Sub pnlINDEXadsr0_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlINDEXadsr0.Paint
    Dim h As Integer = pnlINDEXadsr0.Height
    Dim w As Integer = pnlINDEXadsr0.Width
    Dim g As Graphics = e.Graphics
    Dim p As Pen = New Pen(Color.Blue, 3)
    Dim v As Integer
    Dim c As Char

    With cbNCFadsrA0
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbNCFadsrD0
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbNCFadsrS0
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    With cbNCFadsrR0
      v = Val(.Text)
      If v < 0 Then .Text = "0"
      If v > 16383 Then .Text = "16383"
      For Each c In .Text
        If c > "9" Or c < "0" Then .Text = "0"
      Next
    End With

    Dim P0 As Point = New Point(0, h)
    Dim P1 As Point = New Point(w * 0.3 * ((16383 - Val(cbNCFadsrA0.Text)) / 16383), 0)
    Dim P2 As Point = New Point(P1.X + w * 0.3 * ((16383 - Val(cbNCFadsrD0.Text)) / 16383), ((16383 - Val(cbNCFadsrS0.Text)) / 16383) * h)
    Dim P3 As Point = New Point(P2.X + w * 0.1, ((16383 - Val(cbNCFadsrS0.Text)) / 16383) * h)
    Dim P4 As Point = New Point(P3.X + w * 0.3 * ((16383 - Val(cbNCFadsrR0.Text)) / 16383), h)

    p.Color = Color.ForestGreen
    g.DrawLine(p, P0, P1)

    p.Color = Color.Red
    g.DrawLine(p, P1, P2)

    p.Color = Color.Blue
    g.DrawLine(p, P2, P3)

    p.Color = Color.Black
    g.DrawLine(p, P3, P4)
  End Sub




  '############ INDEX ADSR HANDLERS
  Private Sub cbbINDEXadsr0A_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbNCFadsrA0.TextChanged
    pnlINDEXadsr0.Refresh()
  End Sub
  Private Sub cbbINDEXadsr0D_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbNCFadsrD0.TextChanged
    pnlINDEXadsr0.Refresh()
  End Sub
  Private Sub cbbINDEXadsr0S_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbNCFadsrS0.TextChanged
    pnlINDEXadsr0.Refresh()
  End Sub
  Private Sub cbbINDEXadsr0R_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbNCFadsrR0.TextChanged
    pnlINDEXadsr0.Refresh()
  End Sub
  Private Sub cbbINDEXadsr0A_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNCFadsrA0.Validating
    pnlINDEXadsr0.Refresh()
  End Sub
  Private Sub cbbINDEXadsr0D_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNCFadsrD0.Validating
    pnlINDEXadsr0.Refresh()
  End Sub
  Private Sub cbbINDEXadsr0S_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNCFadsrS0.Validating
    pnlINDEXadsr0.Refresh()
  End Sub
  Private Sub cbbINDEXadsr0R_Validating1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNCFadsrR0.Validating
    pnlINDEXadsr0.Refresh()
  End Sub
  '-------------------------------------------------------------------------------------------------------------




  Function hi(ByVal word As Integer)   ' return high 7 bits of a 14 bit word
    Dim n As Integer
    n = word And &H3FFF
    hi = ((n And &H3F80) / 128)
  End Function
  Function lo(ByVal word As Integer)   ' return low 7 bits of a 14 bit word
    Dim n As Integer
    n = word And &H3FFF
    lo = (n And &H7F)
  End Function
  Sub sendtty(ByVal addrMSB As Integer, ByVal addrLSB As Integer, ByVal datum As Integer)
    Dim outstr As String
    outstr = header & Chr(addrMSB) & Chr(addrLSB) & Chr(datum) & Chr(&HF7)
    serialPort.Write(outstr)
  End Sub

  Private Sub btnSAVE_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSAVE.Click
    With SaveFileDialog1
      .Title = "Save Patch"
      If lblPatchName.Text <> "----------------------------------------" Then
        .FileName = lblPatchName.Text
      End If
      .ShowDialog()
    End With
  End Sub

  Sub saveparm(ByVal b As Byte, ByRef f As System.IO.Stream)
    Dim buf(1) As Byte
    buf(0) = b
    f.Write(buf, 0, 1)
  End Sub

  Private Sub LoadPatch()
    Dim h, l As Integer
    Dim F As System.IO.Stream

    lblPatchName.Text = OpenFileDialog1.FileName
    F = OpenFileDialog1.OpenFile()


    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCO level
    h = F.ReadByte() : l = F.ReadByte() : tbNZlev.Value = h * 128 + l
    lblLev0.Text = tbNZlev.Value.ToString


    ''''''' INDEX ADSR ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    h = F.ReadByte() : l = F.ReadByte() : cbNCFadsrA0.Text = (h * 128 + l).ToString
    h = F.ReadByte() : l = F.ReadByte() : cbNCFadsrD0.Text = (h * 128 + l).ToString
    h = F.ReadByte() : l = F.ReadByte() : cbNCFadsrS0.Text = (h * 128 + l).ToString
    h = F.ReadByte() : l = F.ReadByte() : cbNCFadsrR0.Text = (h * 128 + l).ToString


    ''''''' AMP ADSR ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    h = F.ReadByte() : l = F.ReadByte() : cbNCAadsrA0.Text = (h * 128 + l).ToString
    h = F.ReadByte() : l = F.ReadByte() : cbNCAadsrD0.Text = (h * 128 + l).ToString
    h = F.ReadByte() : l = F.ReadByte() : cbNCAadsrS0.Text = (h * 128 + l).ToString
    h = F.ReadByte() : l = F.ReadByte() : cbNCAadsrR0.Text = (h * 128 + l).ToString

    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE
    h = F.ReadByte() ' FILLER FOR FUTURE USE

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' global transpose
    cbTRANSPOSE.Text = F.ReadByte().ToString()

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' DAC window
    cbDACwindow.Text = F.ReadByte().ToString()
    If cbDACwindow.Text = "-1" Then cbDACwindow.Text = "0"

    ' Expo Release
    h = F.ReadByte() : If h = 1 Then cbNCFexpoRelease0.Checked = True Else cbNCFexpoRelease0.Checked = False

    h = F.ReadByte() : If h = 1 Then cbNCAexpoRelease0.Checked = True Else cbNCAexpoRelease0.Checked = False

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCA Peak modulation source routing
    cbbINDEXadsrPKmodSRC0.SelectedIndex = F.ReadByte()
    ' NCA Sustain modulation source routine
    cbbINDEXadsrSUSmodSRC0.SelectedIndex = F.ReadByte()

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' 63 filler bytes until and unless we use them for something
    ' 59 now, using 4 for velocity tuning


    ' 59 now, using 4 for velocity tuning
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()
    h = F.ReadByte()

    F.Close()

  End Sub

  Private Sub btnLOAD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLOAD.Click
    OpenFileDialog1.ShowDialog()
  End Sub

  Private Sub btnHELP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHELP.Click
    dlgHelp.Show()
  End Sub

  Private Sub GateMan_I_Patch_Editor_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    With SaveFileDialog1
      .Title = "Save Patch"
      '      .ShowDialog()
    End With
  End Sub


  Private Sub SaveFileDialog1_FileOk1(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles SaveFileDialog1.FileOk
    Dim F As System.IO.Stream
    lblPatchName.Text = SaveFileDialog1.FileName
    F = SaveFileDialog1.OpenFile()


    ' NCO level              
    saveparm(CByte(hi(tbNZlev.Value)), F)              '12
    saveparm(CByte(lo(tbNZlev.Value)), F)              '13


    ''''''' INDEX ADSR ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' INDEX ADSR A:
    saveparm(CByte(hi(Val(cbNCFadsrA0.Text))), F)   '
    saveparm(CByte(lo(Val(cbNCFadsrA0.Text))), F)   '

    ' INDEX ADSR D:
    saveparm(CByte(hi(Val(cbNCFadsrD0.Text))), F)   '
    saveparm(CByte(lo(Val(cbNCFadsrD0.Text))), F)   '

    ' INDEX ADSR S:
    saveparm(CByte(hi(Val(cbNCFadsrS0.Text))), F)   '
    saveparm(CByte(lo(Val(cbNCFadsrS0.Text))), F)   '

    ' INDEX ADSR R:
    saveparm(CByte(hi(Val(cbNCFadsrR0.Text))), F)   '
    saveparm(CByte(lo(Val(cbNCFadsrR0.Text))), F)   '

    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' AMP ADSR A:
    saveparm(CByte(hi(Val(cbNCAadsrA0.Text))), F)   '
    saveparm(CByte(lo(Val(cbNCAadsrA0.Text))), F)   '

    ' AMP ADSR D:
    saveparm(CByte(hi(Val(cbNCAadsrD0.Text))), F)   '
    saveparm(CByte(lo(Val(cbNCAadsrD0.Text))), F)   '

    ' AMP ADSR S:
    saveparm(CByte(hi(Val(cbNCAadsrS0.Text))), F)   '
    saveparm(CByte(lo(Val(cbNCAadsrS0.Text))), F)   '

    ' AMP ADSR R:
    saveparm(CByte(hi(Val(cbNCAadsrR0.Text))), F)   '
    saveparm(CByte(lo(Val(cbNCAadsrR0.Text))), F)   '

    ''''''''''''''''''''''''''''''''''''''''''''''''''''
    ''''''''''''''''''''''''''''''''''''''''''''''''''''

    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' global transpose
    saveparm(CByte(Val(cbTRANSPOSE.Text)), F)        '

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' DAC Window
    saveparm(CByte(Val(cbDACwindow.Text)), F)    '

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Expo Release
    Dim ExpoR As Integer
    If cbNCFexpoRelease0.Checked = True Then ExpoR = 1 Else ExpoR = 0 '
    saveparm(ExpoR, F)   ' Expo Release Flag   'page 1, 11



    If cbNCAexpoRelease0.Checked = True Then ExpoR = 1 Else ExpoR = 0 '
    saveparm(ExpoR, F)   ' Expo Release Flag   'page 1, 11



    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCA Peak modulation source routing
    saveparm(CByte(cbbINDEXadsrPKmodSRC0.SelectedIndex), F)  'NOT CURRENTLY IMPLEMENTED
    ' NCA Sustain modulation source routine
    saveparm(CByte(cbbINDEXadsrSUSmodSRC0.SelectedIndex), F) 'NOT CURRENTLY IMPLEMENTED


    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Padding with zeroes, dummy values for future expansion

    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE
    saveparm(0, F)   ' FILLER FOR FUTURE POSSIBLE USE

    F.Close()

  End Sub

  Private Sub OpenFileDialog1_FileOk(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
    LoadPatch()
  End Sub


  Private Sub tbTuningValue_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbTuningValue.Scroll
    lblTuningValue.Text = Format(tbTuningValue.Value / 2097152.0, "0.0000000")
  End Sub



  Private Sub SendPatch()
    lblStatus.Text = "SENDING"
    lblStatus.Refresh()

    'connect, actually, open the serial port
    If Connect() = False Then Exit Sub

    SendPage0()

    SendPage1()

    SendPage2()

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' disconnect, actually, close the serial port 
    ' and wait for the flush to complete
    While serialPort.BytesToWrite > 0
      lblStatus.Text = serialPort.BytesToWrite.ToString
      lblStatus.Refresh()
    End While
    Disconnect()
    lblStatus.Text = "IDLE"
    lblStatus.Refresh()
  End Sub


  Sub SendPage0()
    Dim ExpoR As Integer
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' PAGE 00
    '
    Dim page As Integer
    page = &H0

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' TRANSPOSE
    sendtty(page, &H10, Val(cbTRANSPOSE.Text))


    ''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' AMP ADSR A
    sendtty(page, &H20, hi(Val(cbNCAadsrA0.Text)))
    sendtty(page, &H21, lo(Val(cbNCAadsrA0.Text)))

    ' AMP ADSR D
    sendtty(page, &H22, hi(Val(cbNCAadsrD0.Text)))
    sendtty(page, &H23, lo(Val(cbNCAadsrD0.Text)))

    ' AMP ADSR S
    sendtty(page, &H24, hi(Val(cbNCAadsrS0.Text)))
    sendtty(page, &H25, lo(Val(cbNCAadsrS0.Text)))

    ' AMP ADSR R
    sendtty(page, &H26, hi(Val(cbNCAadsrR0.Text)))
    sendtty(page, &H27, lo(Val(cbNCAadsrR0.Text)))


    ''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCF ADSR A
    sendtty(page, &H30, hi(Val(cbNCFadsrA0.Text)))
    sendtty(page, &H31, lo(Val(cbNCFadsrA0.Text)))

    ' NCF ADSR D
    sendtty(page, &H32, hi(Val(cbNCFadsrD0.Text)))
    sendtty(page, &H33, lo(Val(cbNCFadsrD0.Text)))

    ' NCF ADSR S
    sendtty(page, &H34, hi(Val(cbNCFadsrS0.Text)))
    sendtty(page, &H35, lo(Val(cbNCFadsrS0.Text)))

    ' NCF ADSR R
    sendtty(page, &H36, hi(Val(cbNCFadsrR0.Text)))
    sendtty(page, &H37, lo(Val(cbNCFadsrR0.Text)))


    ''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' NCA expo R
    If cbNCAexpoRelease0.Checked = True Then ExpoR = 1 Else ExpoR = 0
    sendtty(page, &H40, ExpoR)

    If cbNCFexpoRelease0.Checked = True Then ExpoR = 1 Else ExpoR = 0
    sendtty(page, &H41, ExpoR)


    ''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'DAC Window
    sendtty(page, &H7E, Val(cbDACwindow.Text))

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'MIDI CHANNEL
    sendtty(page, &H7F, nudMIDI_CHANNEL.Value - 1)

  End Sub

  Function hexfix(ByVal s As String)
    If s.Length = 1 Then Return "0" & s Else Return s
  End Function

  Sub SendPage1()
    '''''''''''''''''''''''''''''''''''''''''''''''''''
    ' PAGE 01
    '
    Dim q_Scale, q_Min, PmentoRate, NZlev, Lowpass_SVF_q, AmpComp As Long
    Dim s As String
    Dim page As Integer
    page = &H1

    ' q Scale
    q_Scale = CLng(Val(txt_q_Scale.Text) * 17179869183.0)
    sendtty(page, &H0, (q_Scale >> 28) And &H7F)
    sendtty(page, &H1, (q_Scale >> 21) And &H7F)
    sendtty(page, &H2, (q_Scale >> 14) And &H7F)
    sendtty(page, &H3, (q_Scale >> 7) And &H7F)
    sendtty(page, &H4, q_Scale And &H7F)

    lblDIAG.Text = "q_Scale: "
    s = hexfix(Hex((q_Scale >> 28) And &H7F)) : lblDIAG.Text &= s
    s = hexfix(Hex((q_Scale >> 21) And &H7F)) : lblDIAG.Text &= s
    s = hexfix(Hex((q_Scale >> 14) And &H7F)) : lblDIAG.Text &= s
    s = hexfix(Hex((q_Scale >> 7) And &H7F)) : lblDIAG.Text &= s
    s = hexfix(Hex(q_Scale And &H7F)) : lblDIAG.Text &= s
    lblDIAG.Text &= vbCrLf

    ' q Min
    q_Min = CLng(1.0 / Val(txt_q_Min.Text) * 17179869183.0)
    sendtty(page, &H5, (q_Min >> 28) And &H7F)
    sendtty(page, &H6, (q_Min >> 21) And &H7F)
    sendtty(page, &H7, (q_Min >> 14) And &H7F)
    sendtty(page, &H8, (q_Min >> 7) And &H7F)
    sendtty(page, &H9, q_Min And &H7F)

    lblDIAG.Text &= "  q_Min: "
    s = hexfix(Hex((q_Min >> 28) And &H7F)) : lblDIAG.Text &= s
    s = hexfix(Hex((q_Min >> 21) And &H7F)) : lblDIAG.Text &= s
    s = hexfix(Hex((q_Min >> 14) And &H7F)) : lblDIAG.Text &= s
    s = hexfix(Hex((q_Min >> 7) And &H7F)) : lblDIAG.Text &= s
    s = hexfix(Hex(q_Min And &H7F)) : lblDIAG.Text &= s
    lblDIAG.Text &= vbCrLf

    ' Portamento Rate
    PmentoRate = CLng(Val(txtPmentoRate.Text) * 17179869183.0)
    sendtty(page, &HA, (PmentoRate >> 28) And &H7F)
    sendtty(page, &HB, (PmentoRate >> 21) And &H7F)
    sendtty(page, &HC, (PmentoRate >> 14) And &H7F)
    sendtty(page, &HD, (PmentoRate >> 7) And &H7F)
    sendtty(page, &HE, PmentoRate And &H7F)

    ' Noise level
    NZlev = CLng(tbNZlev.Value * 131072.0)
    sendtty(page, &HF, (NZlev >> 28) And &H7F)
    sendtty(page, &H10, (NZlev >> 21) And &H7F)
    sendtty(page, &H11, (NZlev >> 14) And &H7F)
    sendtty(page, &H12, (NZlev >> 7) And &H7F)
    sendtty(page, &H13, NZlev And &H7F)

    ' Lowpass SVF q
    Lowpass_SVF_q = CLng(1.0 / Val(txtLowpass_SVF_Q.Text) * 17179869183.0)
    sendtty(page, &H14, (Lowpass_SVF_q >> 28) And &H7F)
    sendtty(page, &H15, (Lowpass_SVF_q >> 21) And &H7F)
    sendtty(page, &H16, (Lowpass_SVF_q >> 14) And &H7F)
    sendtty(page, &H17, (Lowpass_SVF_q >> 7) And &H7F)
    sendtty(page, &H18, Lowpass_SVF_q And &H7F)

    ' tuning value
    sendtty(page, &H20, (tbTuningValue.Value >> 14) And &H7F)
    sendtty(page, &H21, (tbTuningValue.Value >> 7) And &H7F)
    sendtty(page, &H22, tbTuningValue.Value And &H7F)

    ' Amplitude Compensation (higher tones are louder, this compensates)
    AmpComp = CLng(Val(txtAmpComp.Text) * 17179869183.0)
    sendtty(page, &H25, (AmpComp >> 28) And &H7F)
    sendtty(page, &H26, (AmpComp >> 21) And &H7F)
    sendtty(page, &H27, (AmpComp >> 14) And &H7F)
    sendtty(page, &H28, (AmpComp >> 7) And &H7F)
    sendtty(page, &H29, AmpComp And &H7F)

  End Sub
  Sub SendPage2()
    '''''''''''''''''''''''''''''''''''''''''''''''''''
    ' PAGE 02
    '
    Dim page As Integer
    page = &H2

  End Sub

End Class
